// Certified: 11/22/2006

/*                          CalcDistr.c
	
CALCULATE THE ELECTRON DISTRIBUTION AT  GIVEN Gamma[j] USING THE
EXISTING INFORMATION FOR THE ELECTRON DISTRIBUTION AT THE PREVIOUS 
TIME STEP, AND THE ALREADY CALCULATED ELECTRON DISTRIBUTION AT		    
j+1, j+2, ... N1. NOTE THAT THE DENSITY AT N1 IS ZERO, 
BECAUSE Gamma[N1]>  GammaMax. 

Here it is done in the continuous loss approximation*/

#include "ElectronHead.h"

void CalcDistr(double *Ntemp,int j)
{
  
  double a1,b1,c1,Inj;
  
  a1=DeltaGamma[j]/(DeltaGamma[j]+timestep*(DeltaGamma[j]/tesc - GammaDot[j]));

  b1=-a1*(timestep/DeltaGamma[j])*GammaDot[j+1]; 
 
  c1=a1*timestep;
   
  Inj=Q[j]; 

  Ntemp[j]=a1*N[j]+b1*Ntemp[j+1]+c1*Inj;
   
  return ;
}
 
