// Certified: 11/20/2006

/*                         CalcEs.c
THIS FUNCTION INITIALIZES THE es ARRAY THAT HOLDS THE PHOTON ENERGIES
(IN UNITS OF ELECTRON REST MASS) IN WHICH THE CALCULATIONS ARE
PERFORMED. IT ALSO CALCULATES THE INDEX OF THE MAXIMUM ENERGY AT WHICH 
SYNCHROTRON ENERGY IS EMITTED.
*/

#include "ElectronHead.h"

void CalcEs()
{

  int k;
  double temp;
 
  /* START FORM 100 MHz  */
  es[0]=1.e8 * Planck/(Me*CI*CI);  

  /* THE MAXIMUM PHOTON ENERGY IS GammaMax  */

  es[N2-1]=GammaMax;  

  // POPULATE THE es ARRAY WITH LOGARITHMICALLY SPACED PHOTON ENERGIES

  temp=log10(es[N2-1]/es[0]);                 
 
  for(k=0;k<N2;++k){
    es[k]=es[0]*pow(10,temp*((double) k/(N2-1)));
    loges[k]=log(es[k]);
  }
   
  /* WE ASSUME THAT THE SYNCHROTRON EMISSION CUTTS OF AT 50 TIMES
     THE SYNCHROTRON CRITICAL FREQUENCY OF THE MAXIMUM ENERGY ELECTRON.
     SynchIndex IS THE INDEX OF THE LAST ELEMENT IN es FOR WHICH WE WILL 
     CALCULATE THE SYNCHROTRON EMISSION */

  temp=50.*B*pow(GammaMax,2.)/Bcr;
  for(k=N2-1;k>0;--k)
  {
    if(es[k]>temp)
    continue;
  else
    break;
  }
  SynchIndex=k;
  
  return ;
}
