//Certified: 11/22/2006

/*                            EXTCompton.c

CALCULATION OF THE EXTERNAL COMPTON EMISSION. THIS IS A DOUBLE INTEGRATION
OVER THE ELECTRON AND EXTERNAL PHOTON ENERGY DISTRIBUTIONS */

#include "ElectronHead.h"

double ExtCompton(int v){

  double A,C,Compt,K,temp1,temp2,temp3,temp4,temp5,q=0;
  double *EXTe_Integrand=calloc(N3,sizeof(double));
  double *Gamma_Integrand=calloc(N1+1,sizeof(double));
  int k,j;

  	
  /*(gamma_lower_index[v] IS THE INDEX OF THE LOWER ENERGY ELECTRON
    THAT CAN PRODUCE A FINAL PHOTON OF ENERGY es[v]: 
    Gamma[gamma_lower_index[v]]>es[v]*/

  if(gamma_lower_index[v]>=N1)
    return 0.;

  // EXTseed_upper[v]  IS THE INDEX OF THE MAXIMUM SEED PHOTON ENERGY

  if(EXTseed_upper[v]<=0)
    return 0.;	  
 
  // OUTER INTEGRAL OVER Gamma STARTS
 
  for(j=gamma_lower_index[v];j<N1;++j){
    
    if(EXTseed_lower[j][v]>=N3-1)
      continue;
	       
    if(EXTseed_upper[v]<=EXTseed_lower[j][v])
      return 0.;
   
    temp3=Const2/Gamma_square[j]; //Const2=2*PI*pow(Re,2)*CI

    A=0.;

    // INNER INTEGRAL OVER EXTe  STARTS

    for(k=EXTseed_lower[j][v];k<EXTseed_upper[v];++k){
      EXTe_Integrand[k]= Uext[k]*Cext[v][j][k];
      if ( EXTe_Integrand[k]  < 0. )
	printf("A=%12.4e\n",Cext[v][j][k]);
    }   // INNER INTEGRAL OVER EXTe  ENDS
    
    A=temp3*tab_int(EXTe_Integrand,EXTnorm,
		    EXTseed_lower[j][v],EXTseed_upper[v]);
   
    Gamma_Integrand[j]=A*Gamma_times_N[j];
  }

  
   // INNER INTEGRAL OVER Gamma  ENDS
  
  q=tab_int(Gamma_Integrand,gammanorm,gamma_lower_index[v],N1-1);
  
  /*THE LACK OF CONSTANTS HERE COMES FROM DIVIDING N by  4/3*PI*R^3  */
  Compt=q*es[v];                
                                     
  free(EXTe_Integrand);
  free(Gamma_Integrand);
 
 


 return Compt;
}
