// Certified: 11/22/2006

/*                           Photon_int.c
CALCULATES A SERIES OF N2 INTEGRALS OF THE SOURCE PHOTON ENERGY DENSITY
INTEGRATING THE TABULATED VALUES OF "Photons" FROM THE LOWEST ENERGY 
UP TO THE ith ENERGY. 
THIS  IS USED TO CALCULATE THE THOMSON REGIME LOSSES IN  Gamma_dot.c. 

IT ALSO CALCULATES THE PRODUCT  SRCfotonia[i]=Photons[i]*es[i], WHICH IS
USED IN CALCULATING THE LOSSES IN THE KLEIN-NISHINA REGIME. 

THESE OPERATIONS ARE PERFORMED ONCE PER TIMESTEP, SINCE THEY ONLY DEPEND ON
THE EXISTING SOURCE PHOTON FIELD. */

#include "ElectronHead.h"

void Photon_int()
{
  int i;
  
  // THE ARRAY SRCfotonia HOLDS THE INTEGRANT IN LOGARITHMIC REPRESENTATION
  
  for(i=0;i<N2;++i)
    {
      SRCfotonia[i]=Photons[i]*es[i];
      SRCphotonint[i]=tab_int(SRCfotonia,esnorm,0,i);
    }

  return ;
}
