// Certified: 11/22/2006

/*          SSC.c

CALCULATION OF THE SSC EMISSION. THIS IS A DOUBLE INTEGRATION
OVER THE ELECTRON AND SOURCE PHOTON ENERGY DISTRIBUTIONS*/

#include "ElectronHead.h"

double SSCemission(int v){

  double A,C,q=0, Compt,K,temp3;
  double *SRC_Integrand=calloc(N2,sizeof(double));
  double *Gamma_Integrand=calloc(N1+1,sizeof(double));
  int k,j,upper;


 /*(gamma_lower_index[v] IS THE INDEX OF THE LOWER ENERGY ELECTRON
    THAT CAN PRODUCE A FINAL PHOTON OF ENERGY es[v]: 
    Gamma[gamma_lower_index[v]]>es[v]*/

  if(gamma_lower_index[v]>=N1)
    return 0.;
 
  // OUTER INTEGRAL OVER Gamma STARTS 
  
  for(j=gamma_lower_index[v];j<N1;++j){
    
    temp3=Const2/(Gamma_square[j]);        //Const2=2*PI*pow(Re,2)*CI
    
    if(SRCseed_lower[j][v]>=v)
      continue;
    
    A=0.;
    // INNER INTEGRAL OVER SRC SEED PHOTONS  STARTS
    
    for(k=SRCseed_lower[j][v];k<=v;++k){
      
      SRC_Integrand[k]=Photons[k]*Csrc[v][j][k];
    }	  
    // INNER INTEGRAL OVER SRC PHOTONS  ENDS
    
    A=temp3*tab_int(SRC_Integrand,esnorm,SRCseed_lower[j][v],v);
    Gamma_Integrand[j]=A*Gamma_times_N[j];
        
    }
 // INNER INTEGRAL OVER Gamma  ENDS
  q=tab_int(Gamma_Integrand,gammanorm,gamma_lower_index[v],N1-1);
  
  /*THE LACK OF CONSTANTS HERE COMES FROM DIVIDING N by  4/3*PI*R^3  */
  Compt=q*es[v];
                
  free(SRC_Integrand);
  free(Gamma_Integrand);
 
  return Compt;
}
