// Certified: 11/22/2006

/*                             Synchrotron.c

CALCULATION OF THE SYNCHROTRON EMITTED POWER, FOLLOWING MELROSE'S GREEN'S 
FUNCTION the synchrotron power. THIS IS A SINGLE INTEGRATION OVER THE 
ELECTRON DISTRIBUTION*/

#include "ElectronHead.h"

double Synchrotron(int v)
{
  int j;
  double temp,x,U,synchrotron,x1,x2,y1,y2,
    *synch_integrand=calloc(N1+1,sizeof(double));

  temp=es[v]*Bcr/B;

  for(j=0;j<N1;++j)
    {
	U=0.;
   x=temp/Gamma_square[j];  
    
   if (x<0.03){
       U=1.81*pow(x,0.3333333);
   }
   
   if (x>=10.){
   U=1.57*exp(-x)*(1.-.611/x);
   }

	x1=0.01;
	x2=0.02;
	y1=0.371;
	y2=0.455;
	
/*	if(x>=x1 && x<x2){
	U=(y2-y1)/(x2-x1)*(x-x1);
	} */
	
	x1=x2;
	y1=y2;
	x2=0.03;
	y2=0.508;
	
/*	if(x>=x1 && x<x2){
	U=(y2-y1)/(x2-x1)*(x-x1);
	}*/
	
	x1=x2;
	y1=y2;
	x2=0.04;
	y2=0.546;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=0.05;
	y2=0.576;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=0.06;
	y2=0.600;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}

	x1=x2;
	y1=y2;
	x2=0.07;
	y2=0.620;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=0.08;
	y2=0.636;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}


	x1=x2;
	y1=y2;
	x2=0.09;
	y2=0.650;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=0.1;
	y2=0.661;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=0.2;
	y2=0.711;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=0.3;
	y2=0.705;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=0.4;
	y2=0.678;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=0.5;
	y2=0.641;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=0.6;
	y2=0.600;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=0.7;
	y2=0.559;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}

	x1=x2;
	y1=y2;
	x2=0.8;
	y2=0.517;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=0.9;
	y2=0.477;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}

	x1=x2;
	y1=y2;
	x2=1.0;
	y2=0.439;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=1.1;
	y2=0.403;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=1.2;
	y2=0.370;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=1.3;
	y2=0.338;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=1.4;
	y2=0.309;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=1.5;
	y2=0.283;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}

	x1=x2;
	y1=y2;
	x2=1.6;
	y2=0.258;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}

	x1=x2;
	y1=y2;
	x2=1.7;
	y2=0.235;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}

	x1=x2;
	y1=y2;
	x2=1.8;
	y2=0.214;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}

	x1=x2;
	y1=y2;
	x2=1.9;
	y2=0.195;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=2.0;
	y2=0.178;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=2.5;
	y2=0.111;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=3.0;
	y2=0.068;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}

	x1=x2;
	y1=y2;
	x2=3.5;
	y2=0.042;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=4.0;
	y2=0.026;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=4.5;
	y2=0.016;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=5.;
	y2=0.010;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=5.5;
	y2=0.0059;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=6.0;
	y2=0.0036;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}

	x1=x2;
	y1=y2;
	x2=6.5;
	y2=0.0022;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=7.0;
	y2=0.0013;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}

	x1=x2;
	y1=y2;
	x2=7.5;
	y2=0.00081;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}

	x1=x2;
	y1=y2;
	x2=8.0;
	y2=0.00049;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=8.5;
	y2=0.00030;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=9.0;
	y2=0.00018;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}
	
	x1=x2;
	y1=y2;
	x2=9.5;
	y2=0.00011;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}

	x1=x2;
	y1=y2;
	x2=10.0;
	y2=0.000068;
	
	if(x>=x1 && x<x2){
	U=y1+(y2-y1)/(x2-x1)*(x-x1);
	}

   synch_integrand[j]=Gamma_times_N[j]*U;
  }

  synchrotron=Const3*tab_int(synch_integrand,gammanorm,0,N1);
  
 free(synch_integrand);
return synchrotron;
}
