/*                      tab_int

THE INTEGRAL OF FUNCTION y OVER x. THE TABULATED ARRAY y  IS IN BINS SPACED BY
dx. THE INTEGRATION IS OVER THE VALUES FROM i TO j. METHOD: NEWTON-COTES
*/

#include "ElectronHead.h"

double tab_int(double *y,  double dx, int i, int j)
     
     
{
  double tabint=0.;
  int k;
 
  //MORE THAN SIX POINTS

   if (j-i>5)
     {
       for (k=i;k<=j;k++)
	 {
	   tabint=tabint+y[k];
	 }
       tabint=tabint-
	 0.625*(y[i]+y[j]) +(y[i+1]+y[j-1])*.16667  -(y[i+2]+y[j-2])*4.16667e-2;
        return tabint*dx;
     }     
  

// SIX POINTS
 
   if (j-i==5)
     {
       tabint=0.41666*(y[i]+y[i+5])+ (y[i+2]+y[i+3])+1.08333*(y[i+1]+ y[i+4]);
       return tabint*dx;  
     }  

 // FIVE POINTS
 
   if (j-i==4)
    {
      tabint= 0.31111*(y[i]+y[i+4]) +0.53333*y[i+2] + 1.4222*(y[i+1] + y[i+3]);
      return tabint*dx;    
    }  


 // FOUR POINTS
 
   if (j-i==3)
    {
      tabint= 0.375*(y[i]+y[i+3]) + 1.125*(y[i+1] + y[i+2]) ;
      return tabint*dx;    
    }   
 
 //THREE POINTS 

 if (j-i==2)
    {
      tabint= .3333*y[i]+ 1.3333*y[i+1] + .3333*y[i+2];
      return tabint*dx;
    }  

 //TWO   POINTS 

 if (j-i==1)
    {
      tabint=(y[i]+y[i+1])*.5;
      return tabint*dx;
    } 

  return tabint*dx;
}
 
