(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     15864,        427]
NotebookOptionsPosition[     15471,        409]
NotebookOutlinePosition[     15875,        426]
CellTagsIndexPosition[     15832,        423]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Graphics", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Pink", ",", 
           RowBox[{"Disk", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"13.3", ",", "42.5"}], "}"}], ",", "1.0"}], "]"}]}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Pink", ",", 
           RowBox[{"Disk", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"20.3", ",", "42.2"}], "}"}], ",", "1"}], "]"}]}], 
          "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"Blue", ",", 
           RowBox[{"Disk", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"17.", ",", "45.5"}], "}"}], ",", "1"}], "]"}]}], "}"}],
          ",", 
         RowBox[{"{", 
          RowBox[{"Blue", ",", 
           RowBox[{"Disk", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"25.8", ",", "45.5"}], "}"}], ",", "1"}], "]"}]}], 
          "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"Orange", ",", 
           RowBox[{"Disk", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"15.5", ",", "45."}], "}"}], ",", "1"}], "]"}]}], "}"}],
          ",", 
         RowBox[{"{", 
          RowBox[{"Orange", ",", 
           RowBox[{"Disk", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"23.8", ",", "46"}], "}"}], ",", "1"}], "]"}]}], "}"}], 
         ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"PointSize", "[", "0.03", "]"}], ",", 
         RowBox[{"Point", "[", "Synchrotron", "]"}], ",", 
         RowBox[{"Point", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Compton", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"Compton", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "+", 
             RowBox[{"Synchrotron", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}], "]"}]}], "}"}], ",", 
       
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"11.", ",", "28."}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"40.", ",", " ", "49."}], "}"}]}], "}"}]}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Log \[Nu] (Hz)\>\"", ",", "\"\<Log L (erg/s)\>\""}], 
         "}"}]}], ",", 
       RowBox[{"GridLines", "\[Rule]", "Automatic"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\"\<\[Delta]=\>\"", ",", 
     RowBox[{"29.42", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"10.", "^", 
          RowBox[{"Synchrotron", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "/", 
         RowBox[{"10.", "^", "17"}]}], ")"}], "^", ".5"}], 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"10.", "^", 
           RowBox[{"Synchrotron", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], " ", "/", 
          RowBox[{"10.", "^", "45"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"1.", "/", "6."}], ")"}]}], "\[IndentingNewLine]", "/", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"10.", "^", 
           RowBox[{"Compton", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "/", 
          RowBox[{"(", 
           RowBox[{"2.41", " ", 
            RowBox[{"10", "^", "25"}]}], ")"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"1.", "/", "6."}], ")"}]}]}], " ", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1.", "+", 
          RowBox[{"10.", "^", 
           RowBox[{"Compton", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"1.", "/", "3."}], ")"}]}], "/", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"10.", "^", 
          RowBox[{"Compton", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"1.", "/", "6."}], ")"}]}]}]}], " ", ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\"\<  R in cm:\>\"", ",", 
     
     RowBox[{"5.95", " ", 
      RowBox[{"10", "^", 
       RowBox[{"(", "13", ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"10.", "^", 
          RowBox[{"Synchrotron", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "/", 
         RowBox[{"10.", "^", "17"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "5."}], "/", "2."}], ")"}]}], " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"10.", "^", 
          RowBox[{"Compton", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "/", 
         RowBox[{"(", 
          RowBox[{"2.41", " ", 
           RowBox[{"10", "^", "25"}]}], ")"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"7.", "/", "6."}], ")"}]}], " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"10.", "^", 
          RowBox[{"Synchrotron", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], " ", "/", 
         RowBox[{"10.", "^", "45"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"1.", "/", "3."}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1.", "+", 
         RowBox[{"10.", "^", 
          RowBox[{"Compton", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1."}], "/", "3."}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"10.", "^", 
         RowBox[{"Compton", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1."}], "/", "3."}], ")"}]}]}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\"\<  Tvarmin in s:\>\"", 
     ",", 
     RowBox[{"67.4", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"10.", "^", 
          RowBox[{"Synchrotron", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "/", 
         RowBox[{"10.", "^", "17"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"-", "3."}], ")"}]}], " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"10.", "^", 
          RowBox[{"Compton", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "/", 
         RowBox[{"(", 
          RowBox[{"2.41", " ", 
           RowBox[{"10", "^", "25"}]}], ")"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"4.", "/", "3."}], ")"}]}], "  ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"10.", "^", 
          RowBox[{"Synchrotron", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], " ", "/", 
         RowBox[{"10.", "^", "45"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"1.", "/", "6."}], ")"}]}], " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1.", "+", 
         RowBox[{"10.", "^", 
          RowBox[{"Compton", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2."}], "/", "3."}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"10.", "^", 
         RowBox[{"Compton", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1."}], "/", "6."}], ")"}]}]}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", " ", "\"\<   B=\>\"", ",", 
     
     RowBox[{"5.01", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"10.", "^", 
          RowBox[{"Synchrotron", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "/", 
         RowBox[{"10.", "^", "17"}]}], ")"}], "^", 
       RowBox[{"{", 
        RowBox[{"3", "/", "2"}], "}"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"10.", "^", 
          RowBox[{"Synchrotron", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], " ", "/", 
         RowBox[{"10.", "^", "45"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1."}], "/", "6."}], ")"}]}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"10.", "^", 
          RowBox[{"Compton", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "/", 
         RowBox[{"(", 
          RowBox[{"2.41", " ", 
           RowBox[{"10", "^", "25"}]}], ")"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "5."}], "/", "6."}], ")"}]}], " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1.", "+", 
         RowBox[{"10.", "^", 
          RowBox[{"Compton", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1."}], "/", "3."}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"10.", "^", 
         RowBox[{"Compton", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"1.", "/", "6."}], ")"}]}]}]}], " ", "}"}], ",", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Synchrotron", ",", 
       RowBox[{"{", 
        RowBox[{"12.", ",", "41."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"19.", ",", "48."}], "}"}]}], "}"}], ",", "Locator"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"Compton", ",", 
     RowBox[{"{", 
      RowBox[{"20.", ",", 
       RowBox[{"-", "0.5"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"27.", ",", "2."}], "}"}]}], "}"}], ",", 
   RowBox[{"ControlPlacement", "\[Rule]", "Left"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5371236047011766`*^9, 3.537123608424678*^9}, {
  3.537123914925495*^9, 3.537123915352363*^9}, {3.537140922592107*^9, 
  3.537140956239946*^9}, {3.537140986912636*^9, 3.5371409925929613`*^9}, {
  3.53714106146859*^9, 3.5371410686432447`*^9}, {3.5478503503866673`*^9, 
  3.547850374369585*^9}, {3.547850407392621*^9, 3.547850409247306*^9}, {
  3.547850448799631*^9, 3.547850540954547*^9}, {3.5478505964396763`*^9, 
  3.5478506336862288`*^9}, {3.54785140774118*^9, 3.54785140842898*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`Compton$$ = {25.759999999999998`, 
    0.14}, $CellContext`Synchrotron$$ = {16.66, 45.96}, Typeset`show$$ = True,
     Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`Synchrotron$$], {12., 41.}, {19., 48.}}, Automatic}, {
      Hold[$CellContext`Compton$$], {20., -0.5}, {27., 2.}}}, 
    Typeset`size$$ = {755.1015625, {185.0625, 143.}}, Typeset`update$$ = 0, 
    Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`Compton$4215$$ = {0, 0}}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`Compton$$ = {
         20., -0.5}, $CellContext`Synchrotron$$ = {12., 41.}}, 
      "ControllerVariables" :> {
        Hold[$CellContext`Compton$$, $CellContext`Compton$4215$$, {0, 0}]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> {
        Graphics[{{Pink, 
           Disk[{13.3, 42.5}, 1.]}, {Pink, 
           Disk[{20.3, 42.2}, 1]}, {Blue, 
           Disk[{17., 45.5}, 1]}, {Blue, 
           Disk[{25.8, 45.5}, 1]}, {Orange, 
           Disk[{15.5, 45.}, 1]}, {Orange, 
           Disk[{23.8, 46}, 1]}, 
          PointSize[0.03], 
          Point[$CellContext`Synchrotron$$], 
          Point[{
            Part[$CellContext`Compton$$, 1], Part[$CellContext`Compton$$, 2] + 
            Part[$CellContext`Synchrotron$$, 2]}]}, 
         PlotRange -> {{11., 28.}, {40., 49.}}, Frame -> True, ImageSize -> 
         500, FrameLabel -> {"Log \[Nu] (Hz)", "Log L (erg/s)"}, GridLines -> 
         Automatic], 
        "\[Delta]=", ((
          29.42 (10.^Part[$CellContext`Synchrotron$$, 1]/10.^17)^0.5) ((
            10.^Part[$CellContext`Synchrotron$$, 2]/10.^45)^(1./6.)/(
           10.^Part[$CellContext`Compton$$, 1]/(2.41 10^25))^(1./6.))) ((1. + 
           10.^Part[$CellContext`Compton$$, 2])^(1./3.)/(10.^
          Part[$CellContext`Compton$$, 2])^(1./6.)), 
        "  R in cm:", (((((5.95 
             10^13) (10.^Part[$CellContext`Synchrotron$$, 1]/10.^17)^((-5.)/
              2.)) (10.^Part[$CellContext`Compton$$, 1]/(2.41 10^25))^(7./
             6.)) (10.^Part[$CellContext`Synchrotron$$, 2]/10.^45)^(1./3.)) (
           1. + 10.^Part[$CellContext`Compton$$, 2])^((-1.)/3.)) (10.^
          Part[$CellContext`Compton$$, 2])^((-1.)/3.), 
        "  Tvarmin in s:", ((((
            67.4 (10.^Part[$CellContext`Synchrotron$$, 1]/10.^17)^(-3.)) (
             10.^Part[$CellContext`Compton$$, 1]/(2.41 10^25))^(4./3.)) (
            10.^Part[$CellContext`Synchrotron$$, 2]/10.^45)^(1./6.)) (1. + 
           10.^Part[$CellContext`Compton$$, 2])^((-2.)/3.)) (10.^
          Part[$CellContext`Compton$$, 2])^((-1.)/6.), 
        "   B=", ((((
            5.01 (10.^Part[$CellContext`Synchrotron$$, 1]/10.^17)^{3/2}) (
             10.^Part[$CellContext`Synchrotron$$, 2]/10.^45)^((-1.)/6.)) (
            10.^Part[$CellContext`Compton$$, 1]/(2.41 10^25))^((-5.)/6.)) (1. + 
           10.^Part[$CellContext`Compton$$, 2])^((-1.)/3.)) (10.^
          Part[$CellContext`Compton$$, 2])^(1./6.)}, 
      "Specifications" :> {{{$CellContext`Synchrotron$$, {12., 41.}, {19., 
          48.}}, Automatic, ControlType -> 
         Locator}, {$CellContext`Compton$$, {20., -0.5}, {27., 2.}}}, 
      "Options" :> {ControlPlacement -> Left}, "DefaultOptions" :> {}],
     ImageSizeCache->{938., {193., 201.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{{3.537123486006472*^9, 3.537123500786701*^9}, 
   3.537123589826715*^9, 3.5371239199406357`*^9, {3.5371409312698927`*^9, 
   3.537140956998427*^9}, {3.5371409880453377`*^9, 3.537140993422536*^9}, 
   3.547847186400043*^9, 3.5478473136590567`*^9, 3.54785038123495*^9, 
   3.547850415599758*^9, 3.547850471896896*^9, 3.547850505470392*^9, 
   3.54785055318858*^9, 3.547850650734181*^9, 3.547851411194611*^9},
 FontSize->16]
}, Open  ]]
},
WindowSize->{1244, 802},
WindowMargins->{{123, Automatic}, {-49, Automatic}},
TaggingRules->{"SearchTextTranslated" -> ""},
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 10380, 299, 313, "Input"],
Cell[10950, 323, 4505, 83, 411, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
